//*************************************************************
// ****** No part of this code can be used without concent of
// ****** the author.  
//  http://widget.freestuffcrazy.com/
//
//  Modified to become a search bar for Ebay
//  Many of the original functions still exist
//  5/6/2005
//
//	ORIGINALLY MADE FOR: FreeStuff Viewer
//	Shows the last 10 things listed at
//	freestuffcrazy.com
//
// 	Author: Christopher Wong
//  admin@freestuffcrazy.com
//	Date: 5/1/2005
//  
//  Changed to include auction listings from the
//  my eBay page.
//  Modified: 7/21/2005
//  
//  Now includes the selling table and also
//  International support.
//  Modified: 10/16/2005
//
// Ported over to auctionmonitor.net Login.
// Modified  1/31/2006
//************************************************

var infoFader;
var upFader;
var downFader;
var maxFader;
var frontstretcher;
var main;
var PREFSIZE = 76;
var FULLSIZE = 200;
var RELOADTIME = 1000*60*5;
var lastDate;
var flash;
var flasher;
var timer;
var savedOutput;
var smallsize;
var myeBay;
var getMyeBay
var mode;
var refershing;
var loggedin;

var watchingdiv;
var biddingdiv;
var searchdiv;
var sellingdiv;

var country;

var autologin;

var regTitleA;
var regPriceA;
var watchingTableA;
var biddingTableA;
var regTimeLeftA;
var regitemNumA;
var regmaxbidA;

var t;

var rSearch;
	
function DEBUG(str){
	if(window.widget){
		//alert (str);
		return;
	} else {
		var debugDiv;
	
		debugDiv = document.getElementById("debugDiv");
		debugDiv.appendChild(document.createTextNode(str));
		debugDiv.appendChild(document.createElement("br"));
		debugDiv.scrollTop = debugDiv.scrollHeight;
	}
}

//setup everything
function setup(){
	flash = false;
	smallsize = false;
	country = 0;
	autologin = false;
	
	siteurlA= new Array('http://my.ebay.com/ws/eBayISAPI.dll?MyeBay&rand=',
						'http://my.ebay.co.uk/ws/eBayISAPI.dll?MyeBay&rand=',
						'http://my.ebay.com.au/ws/eBayISAPI.dll?MyeBay&rand=',
						'http://my.ebay.ca/ws/eBayISAPI.dll?MyeBay&rand=',
						'http://my.ebay.it/ws/eBayISAPI.dll?MyeBay&rand=',
						'http://my.ebay.in/ws/eBayISAPI.dll?MyeBay&rand=',
						'http://my.ebay.nl/ws/eBayISAPI.dll?MyeBay&rand=');

	regTitleA=new Array('<td class="c_Title" colspan=".*?">.*?">(([^\*]|[\*])+?)<\/a>',
						'<td class="c_Title" colspan=".*?">.*?">(([^\*]|[\*])+?)<\/a>',
						'<td class="c_Title" colspan=".*?">.*?">(([^\*]|[\*])+?)<\/a>',
						'<td class="c_Title" colspan=".*?">.*?">(([^\*]|[\*])+?)<\/a>',
						'<td class="c_Title" colspan=".*?">.*?">(([^\*]|[\*])+?)<\/a>',
						'<td class="c_Title" colspan=".*?">.*?">(([^\*]|[\*])+?)<\/a>',
						'<td class="c_Title" colspan=".*?">.*?">(([^\*]|[\*])+?)<\/a>');
	
	regPriceA=new Array('<td class="c_CurrentPrice" .*?"><span class="(.*?)">([^\*]+?)</span>',
						'<td class="c_CurrentPrice" .*?"><span class="(.*?)">([^\*]+?)</span>',
						'<td class="c_CurrentPrice" .*?"><span class="(.*?)">([^\*]+?)</span>',
						'<td class="c_CurrentPrice" .*?"><span class="(.*?)">([^\*]+?)</span>',
						'<td class="c_CurrentPrice" .*?"><span class="(.*?)">([^\*]+?)</span>',
						'<td class="c_CurrentPrice" .*?"><span class="(.*?)">([^\*]+?)</span>',
						'<td class="c_CurrentPrice" .*?"><span class="(.*?)">([^\*]+?)</span>');
	
	watchingTableA=new Array('tableName="Watching"(([^\*]|[\*])+?)Back to top<\/a>',
							 'tableName="Watching"(([^\*]|[\*])+?)Back to top<\/a>',
							 'tableName="Watching"(([^\*]|[\*])+?)Back to top<\/a>',
							 'tableName="Watching"(([^\*]|[\*])+?)Back to top<\/a>',
							 'tableName="Watching"(([^\*]|[\*])+?)Torna all\'inizio<\/a>',
							 'tableName="Watching"(([^\*]|[\*])+?)Back to top<\/a>',
							 'tableName="Watching"(([^\*]|[\*])+?)Terug naar boven<\/a>');
	
	biddingTableA=new Array('tableName="Bidding"(([^\*]|[\*])+?)Back to top<\/a>',
							'tableName="Bidding"(([^\*]|[\*])+?)Back to top<\/a>',
							'tableName="Bidding"(([^\*]|[\*])+?)Back to top<\/a>',
							'tableName="Bidding"(([^\*]|[\*])+?)Back to top<\/a>',
							'tableName="Bidding"(([^\*]|[\*])+?)Torna all\'inizio<\/a>',
							'tableName="Bidding"(([^\*]|[\*])+?)Back to top<\/a>',
							'tableName="Bidding"(([^\*]|[\*])+?)Terug naar boven<\/a>');
	
	sellingTableA = new Array('tableName="Selling"(([^\*]|[\*])+?)Back to top<\/a>',
							  'tableName="Selling"(([^\*]|[\*])+?)Back to top<\/a>',
							  'tableName="Selling"(([^\*]|[\*])+?)Back to top<\/a>',
							  'tableName="Selling"(([^\*]|[\*])+?)Back to top<\/a>',
							  'tableName="Selling"(([^\*]|[\*])+?)Torna all\'inizio<\/a>',
							  'tableName="Selling"(([^\*]|[\*])+?)Back to top<\/a>',
							  'tableName="Selling"(([^\*]|[\*])+?)Terug naar boven<\/a>');
	
	regBidsA = new Array('<td class="c_Bids" align="center"><span>([^\*]+?)>([^\*]+?)(</a>)*</span>',
						 '<td class="c_Bids" align="center"><span>([^\*]+?)>([^\*]+?)(</a>)*</span>',
						 '<td class="c_Bids" align="center"><span>([^\*]+?)>([^\*]+?)(</a>)*</span>',
						 '<td class="c_Bids" align="center"><span>([^\*]+?)>([^\*]+?)(</a>)*</span>',
						 '<td class="c_Bids" align="center"><span>([^\*]+?)>([^\*]+?)(</a>)*</span>',
						 '<td class="c_Bids" align="center"><span>([^\*]+?)>([^\*]+?)(</a>)*</span>',
						 '<td class="c_Bids" align="center"><span>([^\*]+?)>([^\*]+?)(</a>)*</span>');
	
	regWatchedA = new Array('<Watchers>([^\*]+?)</Watchers>',
							'<Watchers>([^\*]+?)</Watchers>',
							'<Watchers>([^\*]+?)</Watchers>',
							'<Watchers>([^\*]+?)</Watchers>',
							'<Watchers>([^\*]+?)</Watchers>',
							'<Watchers>([^\*]+?)</Watchers>',
							'<Watchers>([^\*]+?)</Watchers>',
							'<Watchers>([^\*]+?)</Watchers>');
	
	regTimeLeftA=new Array('<td class="c_TimeLeft" align="right".*?<span class="([^\*]*?)">([^\*]+?)<\/span>',
						 	'<td class="c_TimeLeft" align="right".*?<span class="([^\*]*?)">([^\*]+?)<\/span>',
							'<td class="c_TimeLeft" align="right".*?<span class="([^\*]*?)">([^\*]+?)<\/span>',
							'<td class="c_TimeLeft" align="right".*?<span class="([^\*]*?)">([^\*]+?)<\/span>',
							'<td class="c_TimeLeft" align="right".*?<span class="([^\*]*?)">([^\*]+?)<\/span>',
							'<td class="c_TimeLeft" align="right".*?<span class="([^\*]*?)">([^\*]+?)<\/span>',
							'<td class="c_TimeLeft" align="right".*?<span class="([^\*]*?)">([^\*]+?)<\/span>');
	
	regitemNumA=new Array('<td class="c_Title" colspan=".*item=([^\*]+?)&',
  					      '<td class="c_Title" colspan=".*item=([^\*]+?)&',
						  '<td class="c_Title" colspan=".*item=([^\*]+?)&',
						  '<td class="c_Title" colspan=".*item=([^\*]+?)&',
						  '<td class="c_Title" colspan=".*item=([^\*]+?)&',
						  '<td class="c_Title" colspan=".*item=([^\*]+?)&',
						  '<td class="c_Title" colspan=".*item=([^\*]+?)&');
	
	regmaxbidA=new Array('<td class="c_MyMaxBid".*?">.*?>([^\*]+?)<\/span>',
						 '<td class="c_MyMaxBid".*?">.*?>([^\*]+?)<\/span>',
						 '<td class="c_MyMaxBid".*?">.*?>([^\*]+?)<\/span>',
						 '<td class="c_MyMaxBid".*?">.*?>([^\*]+?)<\/span>',
						 '<td class="c_MyMaxBid".*?">.*?>([^\*]+?)<\/span>',
						 '<td class="c_MyMaxBid".*?">.*?>([^\*]+?)<\/span>',
						 '<td class="c_MyMaxBid".*?">.*?>([^\*]+?)<\/span>');
	
	lastDate = "ERROR";
	mode = 1;
	watchingdiv=printMain("Loading List ....");
	biddingdiv=printMain("Loading List ....");
	searchdiv=printMain("Loading List ....");
	sellingdiv=printMain("Loading List ....");
	if(window.widget){
	 if (!(widget.preferenceForKey("mode") === undefined)) {
			mode= widget.preferenceForKey("mode");
	 }
	}
	
	if(window.widget){
	 if (!(widget.preferenceForKey("country") === undefined)) {
			country= widget.preferenceForKey("country");
			document.getElementById("country").value=country;
	 }
	}
	
	if(window.widget){
	 if (!(widget.preferenceForKey("u") === undefined)) {
			document.getElementById("u").value = widget.preferenceForKey("u");
	 }
	}
	if(window.widget){
	 if (!(widget.preferenceForKey("p") === undefined)) {
			document.getElementById("p").value = widget.preferenceForKey("p");
	 }
	}
	
	if(window.widget){
	 if (!(widget.preferenceForKey("reloadtime") === undefined)) {
			RELOADTIME= widget.preferenceForKey("reloadtime");
			document.getElementById("refresh").value=(RELOADTIME/1000);
	 } else {
		RELOADTIME = 1000*60*5; 
	 }
	}


	rSearch = true;



	
	infoFader=new Fader(document.getElementById("flip"), null, 250);
	upFader=new Fader(document.getElementById("up"), null, 250);
	downFader=new Fader(document.getElementById("down"), null, 250);
	maxFader = new Fader(document.getElementById("max"),null,250);
	maxsFader = new Fader(document.getElementById("maxs"),null,250);
	
	frontstretcher = new Stretcher(document.getElementById("front"), FULLSIZE, 500, '');
	prefstretcher = new Stretcher(document.getElementById("front"), PREFSIZE, 500, '');
	
	createGenericButton(document.getElementById("doneButton"), "Back", prefsDone, 67);
	
	scrollerInit(document.getElementById("myScrollBar"), document.getElementById("myScrollTrack"), document.getElementById("myScrollThumb"));
	
	main = document.getElementById("mainContent");
	//stretch();
	//main.style.width = "378px";
	document.getElementById("myScrollTrack").style.display = "block";
	mainContent.style.display = "block";
	updateoutput();
	login();
	//startParser();
	//refreshData();
	
	if(window.widget){
		widget.onshow = onshow;
    	widget.onhide = onhide;
	}
	if(timer == null){
		timer = setInterval("refreshData();", RELOADTIME);
	}

	if(window.widget){
		var issmall = widget.preferenceForKey("issmall");
		if(issmall){
			spin();
		}
	}
   // window.onfocus = reloadData;
    //window.onblur = blur;
}

function spin(){
	topImage = document.getElementById("topImg");
	maindiv = document.getElementById("mainDiv");

	DEBUG("spin");
	if (!smallsize){
		document.getElementById("back").style.display = "none";
		document.getElementById("front").style.display = "none";
		document.getElementById("smallView").style.display = "block";
			
	} else {
		document.getElementById("back").style.display = "none";
		document.getElementById("front").style.display = "block";
		document.getElementById("smallView").style.display = "none";
	}
	smallsize = !smallsize;
	if(window.widget){
		widget.setPreferenceForKey(smallsize,"issmall");
	}
	if (window.widget) {
		window.widget.prepareForTransition("ToBack");
	}
	
	// Set imageSelection from prefs.
	document.getElementById("up").style.display ="none";
	document.getElementById("down").style.display ="block";
	document.getElementById("maxRollie").style.display="none";
	document.getElementById("maxRollies").style.display="none";
	
	
	var stretcherTimeout = 800;
	if (window.widget) {
		setTimeout ('widget.performTransition();', 0);  
	}
}

var rmode; 
function startParser(){
	DEBUG("startParser");
	var d = new Date();
	
	if (!refershing){
		refreshing = true;
		if (t==""){
			login();
		} else {
			getmyeBay();
		}

	}
}

function getmyeBay(){
		DEBUG(" getmyeBay");
		getMyeBay = new XMLHttpRequest();
    	getMyeBay.overrideMimeType("text/xml");
		getMyeBay.onreadystatechange = parseMyeBay;
    	//getMyeBay.open("GET", siteurlA[country] + d.getTime());

		getMyeBay.open("POST", "http://www.auctionmonitor.net/widget/api.php",true);
		//getMyeBay.open("GET", "http://192.168.1.9/api.xml");
		var sendvar="m="+mode+"&t=" + t;
		rmode = mode;
		getMyeBay.send(sendvar);
	
		//getMyeBay.open("GET", "http://192.168.1.5/myebay.html");
}

var nolink;

function parseMyeBay(){
	DEBUG("parseMyeBay: State " + getMyeBay.readyState + " status = " + getMyeBay.status);
	var output;
	
	var fsiteurlA= new Array('ebay.com',
						'ebay.co.uk',
						'ebay.com.au',
						'ebay.ca',
						'ebay.it',
						'ebay.in',
						'ebay.nl');
	
	if (getMyeBay.readyState == 4){
		if(getMyeBay.status == 200){
			DEBUG("STATUS 200");
			var title;
			var price;
			var watching;
			var timeLeft;
			var currentitem;
			var bidding;
			var selling;
			var itemNum;
			var count = 1;
			var pricesplit;
			var bids;
			var watched;
			if (getMyeBay.responseXML){
				myeBay =  getMyeBay.responseXML.documentElement;
			} else {
				return;
			}
			if(myeBay.getElementsByTagName("error").length != 0){
				loggedin = false;
				if (t=="nolink") {
					nolink = true;
				} else {
					nolink = false;
				}
				
				t="";
				DEBUG("BAD USERNAME");
			} else {
				nolink = false;
				loggedin = true;
			}

			//output.firstChild.setAttribute("height", "30px");

			//biddingdiv=printMain(myeBay);
			if (!loggedin){
				// don't do anything
			}
			else if (rmode == 4) { //selling
				output = document.createElement("table");
				output.setAttribute("class", "resultsTable");
				output.setAttribute("width", "89%");
				output.appendChild(makeeBayOutput ("", "Title", "Price","normal", "Timeleft","", "","",""));
				output.appendChild(makeHr());
				if(myeBay.getElementsByTagName("ActiveList")[0].getElementsByTagName("ItemArray").length == 0){
					selling = myeBay.getElementsByTagName("ActiveList")[0].getElementsByTagName("ItemArray");
				} else {
					selling = myeBay.getElementsByTagName("ActiveList")[0].getElementsByTagName("ItemArray")[0].getElementsByTagName("Item");
				}
				
				DEBUG("SELLING TABLE " + selling.length);
				for (var i = 0; i < selling.length; i++) {
					currentitem = selling[i];
					title = currentitem.getElementsByTagName("Title")[0].firstChild.data;
					timeLeft = currentitem.getElementsByTagName("TimeLeft")[0].firstChild.data;
					price = parseFloat(currentitem.getElementsByTagName("CurrentPrice")[0].firstChild.data);
					price = price.toFixed(2) + " " + currentitem.getElementsByTagName("CurrentPrice")[0].getAttribute("currencyID");
					itemNum = currentitem.getElementsByTagName("ItemID")[0].firstChild.data;
					DEBUG("TITLE: " + title);
					DEBUG("TIMELEFT: " + timeLeft);
					DEBUG("PRICE: " + price);
					DEBUG("ITEMNUM: " + itemNum);
					
					/*
					if (bids = regBids.exec(selling[0])){
						DEBUG("BIDS: " + bids[2]);
					}
					if (watched = regWatched.exec(selling[0])){
						DEBUG("WATCHED: " + watched[1]);
					}*/
					//pricesplit = price[2].split("<br>");
					
					output.appendChild(makeeBayOutput(count,title,price,price,timeLeft,itemNum,"",""));
					output.appendChild(makeHr());
					count++;
	
				}
				
				sellingdiv=output;
			} else {
			
				output = document.createElement("table");
				output.setAttribute("class", "resultsTable");
				output.setAttribute("width", "89%");
				output.appendChild(makeeBayOutput ("", "Title", "Price","normal", "Timeleft","", "","",""));
				output.appendChild(makeHr());
				
				if(myeBay.getElementsByTagName("WatchList")[0].getElementsByTagName("ItemArray").length == 0){
					watching = myeBay.getElementsByTagName("WatchList")[0].getElementsByTagName("ItemArray");
				} else {
					watching = myeBay.getElementsByTagName("WatchList")[0].getElementsByTagName("ItemArray")[0].getElementsByTagName("Item");
				}
				DEBUG("WATCHING TABLE " + watching.length);
				for (var i = 0; i < watching.length; i++) {
					currentitem = watching[i];
					
					title = currentitem.getElementsByTagName("Title")[0].firstChild.data;
					timeLeft = currentitem.getElementsByTagName("TimeLeft")[0].firstChild.data;
					price = parseFloat(currentitem.getElementsByTagName("CurrentPrice")[0].firstChild.data);
					price = price.toFixed(2) + " " + currentitem.getElementsByTagName("CurrentPrice")[0].getAttribute("currencyID");
					itemNum = currentitem.getElementsByTagName("ItemID")[0].firstChild.data;
					DEBUG("TITLE: " + title);
					DEBUG("TIMELEFT: " + timeLeft);
					DEBUG("PRICE: " + price);
					DEBUG("ITEMNUM: " + itemNum);
					/*
					//
					if(timeLeft = regTimeLeft.exec(watching[0])){
						//
					}
					if(price = regPrice.exec(watching[0])){
						//
					}
					if (itemNum = regitemNum.exec(watching[0])){
						//
					}
					*/
					
					//pricesplit = price[2].split("<br>");
					
					output.appendChild(makeeBayOutput(count,title,price,"",timeLeft,itemNum,"",""));
					output.appendChild(makeHr());
					count++;
				} 
					
				watchingdiv = output;
				
				output = document.createElement("table");
				output.setAttribute("class", "resultsTable");
				output.setAttribute("width", "89%");
				output.appendChild(makeeBayOutput ("", "Title", "Price","normal", "Timeleft","", "","MaxBid",""));
				output.appendChild(makeHr());
				
				if(myeBay.getElementsByTagName("BidList")[0].getElementsByTagName("ItemArray").length == 0){
					bidding = myeBay.getElementsByTagName("BidList")[0].getElementsByTagName("ItemArray");
				} else {
					bidding = myeBay.getElementsByTagName("BidList")[0].getElementsByTagName("ItemArray")[0].getElementsByTagName("Item");
				}
				DEBUG("BIDDING TABLE " + bidding.length);
				for (var i = 0; i < bidding.length; i++) {
					var priceColor;
					var high;
					var name;
					currentitem = bidding[i];				
						
					title = currentitem.getElementsByTagName("Title")[0].firstChild.data;
					timeLeft = currentitem.getElementsByTagName("TimeLeft")[0].firstChild.data;
					price = parseFloat(currentitem.getElementsByTagName("CurrentPrice")[0].firstChild.data);
					price = price.toFixed(2) + " " + currentitem.getElementsByTagName("CurrentPrice")[0].getAttribute("currencyID");
					itemNum = currentitem.getElementsByTagName("ItemID")[0].firstChild.data;
					DEBUG("TITLE: " + title);
					DEBUG("TIMELEFT: " + timeLeft);
					DEBUG("PRICE: " + price);
					DEBUG("ITEMNUM: " + itemNum);
					maxbid = parseFloat(currentitem.getElementsByTagName("MaxBid")[0].firstChild.data);
					maxbid = maxbid.toFixed(2) + " " + currentitem.getElementsByTagName("MaxBid")[0].getAttribute("currencyID");
					high = currentitem.getElementsByTagName("HighBidder")[0].getElementsByTagName("UserID")[0].firstChild.data;
					name = myeBay.getElementsByTagName("BidList")[0].getElementsByTagName("name")[0].firstChild.data;
					
					if (high == name){
						
						priceColor="success";
					} else {
						DEBUG ("high: " + high);
						DEBUG ("name: " + name);
						priceColor="failed";
					}
					
					output.appendChild(makeeBayOutput(count,title,price,priceColor,timeLeft,itemNum,maxbid,""));
					output.appendChild(makeHr());
					count++;
				}
				
				biddingdiv=output;			
			}
			
			if (!loggedin){
				if (!nolink){
					biddingdiv=printMain2("Your login information is incorrect<br>Please enter your Auctionmonitor.net login information<br> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Click here for help","http://www.auctionmonitor.net/widget.php");
					watchingdiv=printMain2("Your login information is incorrect<br>Please enter your Auctionmonitor.net login information<br> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Click here for help","http://www.auctionmonitor.net/widget.php");
					sellingdiv=printMain2("Your login information is incorrect<br>Please enter your Auctionmonitor.net login information<br> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Click here for help","http://www.auctionmonitor.net/widget.php");
				} else {
					biddingdiv=printMain2("No eBay Account linked.  Please login at Auctionmonitor.net and link an eBay account","http://www.auctionmonitor.net");
					watchingdiv=printMain2("No eBay Account linked.  Please login at Auctionmonitor.net and link an eBay account","http://www.auctionmonitor.net");
					sellingdiv=printMain2("No eBay Account linked.  Please login at Auctionmonitor.net and link an eBay account","http://www.auctionmonitor.net");

				}
			}
			updateoutput();
			refreshing = false;

		}
	} else if ((getMyeBay.readyState == 3)&&!loggedin){
		biddingdiv=printMain("Loading.");
		watchingdiv=printMain("Loading.");
		sellingdiv=printMain("Loading.");
		updateoutput();
		
	} else if ((getMyeBay.readyState == 2)&&!loggedin){
		biddingdiv=printMain("Loading..");
		watchingdiv=printMain("Loading..");
		sellingdiv=printMain("Loading..");
		updateoutput();
		
	} else if ((getMyeBay.readyState == 1)&&!loggedin){
		biddingdiv=printMain("Loading....");
		watchingdiv=printMain("Loading....");
		sellingdiv=printMain("Loading....");
		updateoutput();
	}
	
}

function updateoutput(){
	if(window.widget){
		widget.setPreferenceForKey(mode,"mode");
	}
	switch (mode) 
	{
	case 1: //bidding mode
	  document.getElementById("se").style.color="#000099";
	  document.getElementById("bi").style.color="#FF0000";
	  document.getElementById("wa").style.color="#000099";
	  document.getElementById("rs").style.color="#000099";
	  if (main.firstChild) {
			main.removeChild(main.firstChild);
		} 
		main.appendChild(biddingdiv);
	  
	  break;
	case 2: //watching mode
	  document.getElementById("se").style.color="#000099";
	  document.getElementById("bi").style.color="#000099";
	  document.getElementById("wa").style.color="#FF0000";
	  document.getElementById("rs").style.color="#000099";
	  if (main.firstChild) {
			main.removeChild(main.firstChild);
			if (main.firstChild) {
				main.removeChild(main.firstChild);
	  		} 
	  } 
	  main.appendChild(watchingdiv);
	  
	  break;
	case 3: //search mode
	  document.getElementById("se").style.color="#000099";
	  document.getElementById("bi").style.color="#000099";
	  document.getElementById("wa").style.color="#000099";
	  document.getElementById("rs").style.color="#FF0000";
	  if (main.firstChild) {
			main.removeChild(main.firstChild);
		} 
		main.appendChild(searchdiv);
	  
	  break;
	  	case 4: //selling mode
	  document.getElementById("bi").style.color="#000099";
	  document.getElementById("wa").style.color="#000099";
	  document.getElementById("se").style.color="#FF0000";
	  document.getElementById("rs").style.color="#000099";
	  if (main.firstChild) {
			main.removeChild(main.firstChild);
		} 
		main.appendChild(sellingdiv);
	  
	  break;
	  default:
	  	mode=1;
		break;
	}
	calculateAndShowThumb(main);  
}

function makeeBayOutput (num, title, price,priceColor, timeleft, itemnum, maxbid,watched){
	var timecolor="";
	title = title.replace(/^\s*|\s*$/g,"");
	price = price.replace(/<img .*?>/i,"");
	price = price.replace(/^\s*|\s*$/g,"");
	if (timeleft != "Timeleft"){
		timeleft = timeleft.replace(/P|T/g,"");
		timeleft = timeleft.replace(/D/g,"d ");
		timeleft = timeleft.replace(/H/g,"h ");
		timeleft = timeleft.replace(/M/g,"m ");
		timeleft = timeleft.replace(/S/g,"s");
		if (!timeleft.match("d")){
			timecolor="Red";
		}
	}
	itemnum = itemnum.replace(/^\s*|\s*$/g,"");
	
	var output =document.createElement("tr");
	var newtd = document.createElement("td");
	var newspan;
	// For screen shot
	/*if (num ==1){
		output.setAttribute("id", "span"+num);
		output.setAttribute("onMouseOver", "highliteEbay('span"+num+"');");
		output.setAttribute("onMouseOut", "document.getElementById('span"+num + "').className='fronttexthighlitebg';");
	}
	else*/ if(num != ""){
		output.setAttribute("id", "span"+num);
		output.setAttribute("onMouseOver", "highliteEbay('span"+num+"');");
		output.setAttribute("onMouseOut", "document.getElementById('span"+num + "').className='fronttextebay';");
	}
	output.setAttribute("class", "fronttextebay");
	if(itemnum !=""){
		output.setAttribute("onClick",'window.widget.openURL("http://www.auctionmonitor.net/item.php?version=3.5&id=' +itemnum+'&c='+country+'");');
	}
	newtd.innerHTML = title;
	output.appendChild(newtd);
	
	newtd = document.createElement("td");
	newspan = document.createElement("span");
	newspan.innerHTML = price;
	newspan.setAttribute("class", priceColor);
	//newtd.innerHTML = price;
	newtd.appendChild(newspan);
	
	output.appendChild(newtd);
	
	if(maxbid != ""){
		newtd = document.createElement("td");
		newtd.innerHTML = maxbid;
		output.appendChild(newtd);
	}
	if(watched != ""){
		newtd = document.createElement("td");
		newtd.innerHTML = watched;
		output.appendChild(newtd);
	}
	newtd = document.createElement("td");
	newspan = document.createElement("span");
	if(timeleft != "0s"){
		newspan.innerHTML = timeleft;
	} else {
		newspan.innerHTML = "Ended";
		timecolor = "";
	}
	
	newspan.setAttribute("class", timecolor);
	newtd.appendChild(newspan);
	output.appendChild(newtd);

	return output;
}

function makeHr(){
	var output =document.createElement("tr");
	var newtd = document.createElement("td");
	newtd .setAttribute("colspan", "5");
	newtd .setAttribute("class", "hline");
	output.appendChild(newtd);
	return output;
	
}

function refreshData(){
	var d;
	d = new Date();
	//DEBUG("refresh");
	
	if (frontstretcher.isStretched()) {
		startParser();
		xmlResponse = new XMLHttpRequest();
		xmlResponse.onreadystatechange = handleStateChange;
		//this gets the data for the last X searches to display in the blue tray
		xmlResponse.open("GET", "http://www.freestuffcrazy.com/ebaywidget/data.php?version=3.5&id=" + d.getTime(), true);
		xmlResponse.send(null);
	}
}

function handleStateChange(){
	var i;
	var d;
	var file;
	var output = document.createElement("div");
	output.setAttribute("class", "resultsDiv");

	if (xmlResponse.readyState == 4){
		if(xmlResponse.status == 200){
			response = xmlResponse.responseXML.documentElement;
			output = document.createElement("div");
			output.setAttribute("class", "resultsDiv");
			if(response.getElementsByTagName('la').length >= 1){				
				output.appendChild(makeOutput ("title1", response.getElementsByTagName('la')[0].firstChild.data, response.getElementsByTagName('ua')[0].firstChild.data));
				output.appendChild(document.createElement("br"));
			}
			output.appendChild(makeOutput ("title", response.getElementsByTagName('t')[0].firstChild.data, ""));
			output.appendChild(document.createElement("br"));
			
			
			for( i = 0; i < response.getElementsByTagName('l').length; i++){
				output.appendChild (makeOutput(i,response.getElementsByTagName('l')[i].firstChild.data, response.getElementsByTagName('u')[i].firstChild.data));
				output.appendChild(document.createElement("br"));
			}

			
			if (frontstretcher.isStretched()) {
				//everything went fine output results

				//lastDate = response.getElementsByTagName('u')[0].firstChild.data;
				searchdiv = output;				
				//if (main.firstChild) {
					//main.removeChild(main.firstChild);
				//} 
				//main.appendChild(savedOutput);
			} else {
				/*
				DEBUG("newspan");
				var newDate = response.getElementsByTagName('u')[0].firstChild.data.toString();
				DEBUG(newDate + " " +lastDate);
				if(lastDate != newDate){
					DEBUG("flash");
					flash = true;
					
					flasher = setInterval("updateFlash();", 1000);
					lastDate = response.getElementsByTagName('u')[0].firstChild.data;

				} 
				 savedOutput = output;
			
				printMain("Last Update: " + lastDate);*/
				searchdiv = output;
			}			
			//startParser();
			updateoutput();
		}
		else {
			//error
			updateoutput();
			debugDiv.appendChild(document.createTextNode("error"));
			debugDiv.appendChild(document.createElement("br"));
			debugDiv.scrollTop = debugDiv.scrollHeight;
		}
	}
}

function makeOutput (num, title, url){
	var output =document.createElement("span");
	output.setAttribute("id", "span"+num);
	output.setAttribute("class", "fronttext");
	output.setAttribute("onMouseOver", "highlite('span"+num+"');");
	output.setAttribute("onMouseOut", "document.getElementById('span"+num + "').className='fronttext';");
	output.setAttribute("onClick",'window.widget.openURL("' +url+'&c='+country+'");');
	output.innerHTML = title;

	return output;
}

function printMain(str){
	var newA = document.createElement("a");
	var newCenter = document.createElement("center");
	var newRefresh = document.createElement("a");
	
	newCenter.appendChild(document.createElement("br"));
	newCenter.appendChild(document.createElement("br"));
	

	
	newA.setAttribute("id", "logintext");
	newA.setAttribute("href", "#");
	newA.setAttribute("class", "fronttext");
	newA.setAttribute("onMouseOver", "highlite('logintext');");
	newA.setAttribute("onMouseOut", "document.getElementById('logintext').className='fronttext';");
	newA.setAttribute("onClick",'window.widget.openURL("http://www.freestuffcrazy.com/ebaywidget/signin.php?version=3.5&c="+country);');
	newA.innerHTML = str+"&nbsp;&nbsp;&nbsp;";
	newCenter.appendChild(newA);
	
	
	newRefresh.setAttribute("id", "logintextR");
	newRefresh.setAttribute("href", "#");
	newRefresh.setAttribute("class", "fronttext");
	newRefresh.setAttribute("onMouseOver", "highlite('logintextR');");
	newRefresh.setAttribute("onMouseOut", "document.getElementById('logintextR').className='fronttext';");
	newRefresh.setAttribute("onClick",'refreshData();');
	newRefresh.innerHTML = "Reload&nbsp;";
	newCenter.appendChild(document.createElement("br"));
	newCenter.appendChild(document.createElement("br"));
	newCenter.appendChild(newRefresh);
	
	//output.setAttribute("height","300px");
	return newCenter;
}


function printMain2(str,url){
	var newA = document.createElement("a");
	var newCenter = document.createElement("center");
	var newRefresh = document.createElement("a");
	
	newCenter.appendChild(document.createElement("br"));
	newCenter.appendChild(document.createElement("br"));
	

	
	newA.setAttribute("id", "logintext");
	newA.setAttribute("href", "#");
	newA.setAttribute("class", "fronttext");
	newA.setAttribute("onMouseOver", "highlite('logintext');");
	newA.setAttribute("onMouseOut", "document.getElementById('logintext').className='fronttext';");
	newA.setAttribute("onClick",'widget.openURL("'+url+'");');
	newA.innerHTML = str+"&nbsp;&nbsp;&nbsp;";
	newCenter.appendChild(newA);
	
	
	newRefresh.setAttribute("id", "logintextR");
	newRefresh.setAttribute("href", "#");
	newRefresh.setAttribute("class", "fronttext");
	newRefresh.setAttribute("onMouseOver", "highlite('logintextR');");
	newRefresh.setAttribute("onMouseOut", "document.getElementById('logintextR').className='fronttext';");
	newRefresh.setAttribute("onClick",'refreshData();');
	newRefresh.innerHTML = "Reload&nbsp;";
	newCenter.appendChild(document.createElement("br"));
	newCenter.appendChild(document.createElement("br"));
	newCenter.appendChild(newRefresh);
	
	//output.setAttribute("height","300px");
	return newCenter;
}

function prefsDone(){
	//save prefernces
	//go back to front
	//DEBUG("prefstretcher ");
	if(window.widget){
		widget.setPreferenceForKey(document.getElementById("p").value,"p");
		widget.setPreferenceForKey(document.getElementById("u").value,"u");
		
	}
	login();
	goToFront();
	printMain("Last Update: " + lastDate);
	//frontstretcher.maxPosition = frontstretcher.minPoshition + frontstretcher.stretchDistance;
}

function goToFront () {
	//DEBUG("goToFront");
	if (window.widget) {
		window.widget.prepareForTransition("ToFront");
	}
	
	// Set imageSelection from prefs.
	document.getElementById("back").style.display = "none";
	document.getElementById("front").style.display = "block";
	document.getElementById("up").style.display ="none";
	document.getElementById("down").style.display ="block";
	
	
	var stretcherTimeout = 800;
	if (window.widget) {
		setTimeout ('widget.performTransition();', 0);  
	}
	setTimeout ('stretch();', 800);
}


function flipClick (event) {

		//frontstretcher.onFinished = showBack;
		//frontstretcher.onFinished = refreshData;
		prefstretcher.onFinished = showBack;
		//DEBUG("prefstretcher ");
		if(!frontstretcher.isStretched()){
			//frontstretcher.onFinished = preStretch;
			frontstretcher.onFinished = showBack;
			frontstretcher.stretch(event);
			
		} else {
			//prefstretcher.stretch(event);
			showBack();
		}
}

function preStretch(){
	prefstretcher.onFinished = showBack;
	prefstretcher.stretch(event);
}

function stretch(){
	flash = false;
	frontstretcher.onFinished = refreshData;
	document.getElementById("upr").style.display="none";
	document.getElementById("downr").style.display="none";
	if(!frontstretcher.isStretched()){
		document.getElementById("up").style.display="block";
		document.getElementById("down").style.display="none";
		//printMain("Loading List ....");
	} else {
		document.getElementById("up").style.display="none";
		document.getElementById("down").style.display="block";
		//printMain("Last Update: " + lastDate);
	}
	frontstretcher.stretch();
}

function down (){
	frontstretcher.onFinished = refreshData;
	document.getElementById("upr").style.display="none";
	document.getElementById("downr").style.display="none";
	if(!frontstretcher.isStretched()){
		document.getElementById("up").style.display="block";
		document.getElementById("down").style.display="none";
		//printMain("Loading List ....");
		frontstretcher.stretch();
	} 
}

function showBack(){
	if (window.widget) {
		window.widget.prepareForTransition("ToBack");
	}
	
	document.getElementById("fliprollie").style.display = "none";
	// get image selection from prefs; otherwise set 1.
	document.getElementById("front").style.display = "none";
	document.getElementById("back").style.display = "block";
	if (window.widget){
		setTimeout ('widget.performTransition();', 0);
	}
}


function highlite(name){
	document.getElementById(name).className='fronttexthighlite';
	//alert(document.getElementById(name).className);
}
function highliteEbay(name){
	document.getElementById(name).className='fronttexthighlitebg';
	//alert(document.getElementById(name).className);
}

function onshow () {
	
    if (timer == null) {
		refreshData();
        timer = setInterval("refreshData();", RELOADTIME);
    }
}
function onhide () {
    if (timer != null) {
        clearInterval(timer);
        timer = null;
    }
}

function fadeInfoButton() {
	if(smallsize){
		if(!maxsFader.fadingIn){
			maxsFader.startFade(maxsFader.now, 1);
			maxsFader.fadingIn=true;
		}
			
	}else{
	
		if (!infoFader.fadingIn) {
			infoFader.startFade(infoFader.now, 1);
			infoFader.fadingIn = true;
		}
		if(!upFader.fadingIn){
			upFader.startFade(upFader.now, 1);
			upFader.fadingIn=true;
		}
		if(!downFader.fadingIn){
			downFader.startFade(downFader.now, 1);
			downFader.fadingIn=true;
		}
		if(!maxFader.fadingIn){
			maxFader.startFade(maxFader.now, 1);
			maxFader.fadingIn=true;
		}
	}
} 
function fadeOutInfoButton() {
	infoFader.fadeOut();
	upFader.fadeOut();
	downFader.fadeOut();
	maxFader.fadeOut();
	maxsFader.fadeOut();
} 

function showPrefs()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
        
    if (window.widget)
        widget.prepareForTransition("ToBack");
                
    front.style.display="none";
    back.style.display="block";
        
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
}


function countryChanged(value){
	country = value.value;
	if(window.widget){
		widget.setPreferenceForKey(value.value,"country");
	}
	watchingdiv=printMain("Loading....");
	biddingdiv=printMain("Loading....");
 	sellingdiv=printMain("Loading....");
}

function searchChanged(value){
	rSearch = value.checked;
	if(window.widget){
		widget.setPreferenceForKey(value.value,"rSearch");
	}
	return;
}


function refreshChanged(value){
	RELOADTIME = value.value*1000;
	if(timer != null){
        clearInterval(timer);
	}
    timer = setInterval("refreshData();", RELOADTIME);
	if(window.widget){
		widget.setPreferenceForKey(RELOADTIME,"reloadtime");
	}
	
}

var loginResponse;
var MyeBay;

function login(){
	//autologin = document.getElementById("auto").checked;
	if (!autologin){
		var d;
		autologin = true;
		d = new Date();
		var postvars = "";
	//if (!refershing){
		//startParser();
		postvars +="MfcISAPICommand=SignInWelcome&";
		postvars +="siteid=0&";
		postvars +="co_partnerId=2&";
		postvars +="UsingSSL=1&";
		postvars +="pp=&";
		postvars +="pa1=&";
		postvars +="pa2=&";
		postvars +="pa3=&";
		postvars +="i1=-1&";
		postvars +="pageType=1883&";
		postvars +="rtmData=A01=AAAAQCVBAAAAAAAAQQD;M01=A;PS=T.0&";
//		postvars +="migrateVisitor=1&";
		postvars +="e="+document.getElementById("u").value+"&";
		postvars +="d="+document.getElementById("p").value+"&";
		postvars +="keepMeSignInOption=1";
		DEBUG("AUTOLOGIN: " + autologin);
		
		MyeBay = new XMLHttpRequest();
		MyeBay.onreadystatechange = handleLogin;
		//this gets the data for the last X searches to display in the blue tray
		MyeBay.open("POST", "http://www.auctionmonitor.net/widget/token.php", true);
		//MyeBay.open("POST", "http://widget.freestuffcrazy.com/posttest.php", true);
		DEBUG("Trying to login");
		MyeBay.send(postvars);
		
	} else {
		return;
	}
}

function handleLogin(){

	if (MyeBay.readyState == 4){
		if(MyeBay.status == 200){
			
			t = MyeBay.responseText;
			DEBUG("logined in" + t);
			//startParser();
			autologin = false;
			getmyeBay();
		}
	}
}

function auto(value){
	var stuff= document.getElementById("login");
	autologin = value.checked;
	if (value.checked){
		stuff.style.display="block";
	} else {
		stuff.style.display="none";
	}
}

function hidePrefs()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
        
    if (window.widget)
        widget.prepareForTransition("ToFront");
                
    back.style.display="none";
    front.style.display="block";
        
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}

//INFO Button Code
var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};
function mousemove (event)
{
    if (!flipShown)
    {
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 1.0;
        animate();
        flipShown = true;
    }
}

function mouseexit (event)
{
    if (flipShown)
    {
        // fade in the info button
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 0.0;
        animate();
        flipShown = false;
    }
}


function animate()
{
    var T;
    var ease;
    var time = (new Date).getTime();
                
        
    T = limit_3(time-animation.starttime, 0, animation.duration);
        
    if (T >= animation.duration)
    {
        clearInterval (animation.timer);
        animation.timer = null;
        animation.now = animation.to;
    }
    else
    {
        ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
        animation.now = computeNextFloat (animation.from, animation.to, ease);
    }
        
    animation.firstElement.style.opacity = animation.now;
}
function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}
function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

function openSearch(value){
	//DEBUG("HI");
	var searchstring;
	if (rSearch){
		searchstring = 'http://www.freestuffcrazy.com/ebaywidget/checkString.php?version=3.5&c='+country+'&q=';
	} else {
		s = new String(value);
		s2= new String(value);
		s=s.replace(" ","-");
		s=s.replace("%20","-");
		s2=s2.replace(" ","Q20");
		s2=s2.replace("%20","Q20");
		searchstring = 'http://search.'+fsiteurlA[preferences.country.value]+'/'+s+'_W0QQsatitleZ' + s2;
	}
	           
	var url = searchstring +  encodeURI(value.replace(/[\s]/gi, '+'));
	DEBUG(url);
	//window.open(url);
	widget.openURL(url);
}

function replaceAll( str, from, to ) {
    var idx = str.indexOf( from );

    while ( idx > -1 ) {
        str = str.replace( from, to ); 
        idx = str.indexOf( from );
    }

    return str;
}